// FullAccess
resource "azurerm_role_definition" "azure_resource_manager_fullaccess_definition" {
  name              = "azure-resource-manager-fullaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.Addons/register/action",
      "Microsoft.Addons/supportProviders/supportPlanTypes/read",
      "Microsoft.Addons/supportProviders/supportPlanTypes/write",
      "Microsoft.Addons/supportProviders/supportPlanTypes/delete",
      "Microsoft.Addons/operations/read",
      "Microsoft.Addons/supportProviders/listsupportplaninfo/action",
      "Microsoft.Authorization/elevateAccess/action",
      "Microsoft.Authorization/classicAdministrators/read",
      "Microsoft.Authorization/classicAdministrators/write",
      "Microsoft.Authorization/classicAdministrators/delete",
      "Microsoft.Authorization/roleAssignments/read",
      "Microsoft.Authorization/roleAssignments/write",
      "Microsoft.Authorization/roleAssignments/delete",
      "Microsoft.Authorization/permissions/read",
      "Microsoft.Authorization/locks/read",
      "Microsoft.Authorization/locks/write",
      "Microsoft.Authorization/locks/delete",
      "Microsoft.Authorization/roleDefinitions/read",
      "Microsoft.Authorization/roleDefinitions/write",
      "Microsoft.Authorization/roleDefinitions/delete",
      "Microsoft.Authorization/providerOperations/read",
      "Microsoft.Authorization/policySetDefinitions/read",
      "Microsoft.Authorization/policySetDefinitions/write",
      "Microsoft.Authorization/policySetDefinitions/delete",
      "Microsoft.Authorization/policyDefinitions/read",
      "Microsoft.Authorization/policyDefinitions/write",
      "Microsoft.Authorization/policyDefinitions/delete",
      "Microsoft.Authorization/policyAssignments/read",
      "Microsoft.Authorization/policyAssignments/write",
      "Microsoft.Authorization/policyAssignments/delete",
      "Microsoft.Authorization/operations/read",
      "Microsoft.Authorization/classicAdministrators/operationstatuses/read",
      "Microsoft.Authorization/denyAssignments/read",
      "Microsoft.Authorization/denyAssignments/write",
      "Microsoft.Authorization/denyAssignments/delete",
      "Microsoft.Features/register/action",
      "Microsoft.Features/operations/read",
      "Microsoft.Features/features/read",
      "Microsoft.Features/providers/features/read",
      "Microsoft.Features/providers/features/register/action",
      "Microsoft.Features/providers/features/unregister/action",
      "Microsoft.Management/checkNameAvailability/action",
      "Microsoft.Management/getEntities/action",
      "Microsoft.Management/register/action",
      "Microsoft.Management/managementGroups/read",
      "Microsoft.Management/managementGroups/write",
      "Microsoft.Management/managementGroups/delete",
      "Microsoft.Management/managementGroups/subscriptions/write",
      "Microsoft.Management/managementGroups/subscriptions/delete",
      "Microsoft.Resources/checkResourceName/action",
      "Microsoft.Resources/checkPolicyCompliance/action",
      "Microsoft.Resources/tenants/read",
      "Microsoft.Resources/providers/read",
      "Microsoft.Resources/resources/read",
      "Microsoft.Resources/subscriptions/read",
      "Microsoft.Resources/subscriptions/resources/read",
      "Microsoft.Resources/subscriptions/locations/read",
      "Microsoft.Resources/subscriptions/providers/read",
      "Microsoft.Resources/subscriptions/operationresults/read",
      "Microsoft.Resources/subscriptions/resourceGroups/read",
      "Microsoft.Resources/subscriptions/resourceGroups/write",
      "Microsoft.Resources/subscriptions/resourceGroups/delete",
      "Microsoft.Resources/subscriptions/resourceGroups/moveResources/action",
      "Microsoft.Resources/subscriptions/resourceGroups/validateMoveResources/action",
      "Microsoft.Resources/subscriptions/resourcegroups/resources/read",
      "Microsoft.Resources/subscriptions/tagNames/read",
      "Microsoft.Resources/subscriptions/tagNames/write",
      "Microsoft.Resources/subscriptions/tagNames/delete",
      "Microsoft.Resources/subscriptions/tagNames/tagValues/read",
      "Microsoft.Resources/subscriptions/tagNames/tagValues/write",
      "Microsoft.Resources/subscriptions/tagNames/tagValues/delete",
      "Microsoft.Resources/deployments/read",
      "Microsoft.Resources/deployments/write",
      "Microsoft.Resources/deployments/delete",
      "Microsoft.Resources/deployments/cancel/action",
      "Microsoft.Resources/deployments/validate/action",
      "Microsoft.Resources/deployments/whatIf/action",
      "Microsoft.Resources/subscriptions/resourcegroups/deployments/read",
      "Microsoft.Resources/subscriptions/resourcegroups/deployments/write",
      "Microsoft.Resources/subscriptions/resourcegroups/deployments/operations/read",
      "Microsoft.Resources/subscriptions/resourcegroups/deployments/operationstatuses/read",
      "Microsoft.Resources/deployments/operations/read",
      "Microsoft.Resources/links/read",
      "Microsoft.Resources/links/write",
      "Microsoft.Resources/links/delete",
      "Microsoft.Resources/tags/read",
      "Microsoft.Resources/tags/write",
      "Microsoft.Resources/tags/delete",
    ]

    not_actions = []
  }
}

// ReadOnly
resource "azurerm_role_definition" "azure_resource_manager_readonly_definition" {
  name              = "azure-resource-manager-readonly-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.Addons/supportProviders/supportPlanTypes/read",
      "Microsoft.Addons/operations/read",
      "Microsoft.Authorization/classicAdministrators/read",
      "Microsoft.Authorization/roleAssignments/read",
      "Microsoft.Authorization/permissions/read",
      "Microsoft.Authorization/locks/read",
      "Microsoft.Authorization/roleDefinitions/read",
      "Microsoft.Authorization/providerOperations/read",
      "Microsoft.Authorization/policySetDefinitions/read",
      "Microsoft.Authorization/policyDefinitions/read",
      "Microsoft.Authorization/policyAssignments/read",
      "Microsoft.Authorization/operations/read",
      "Microsoft.Authorization/classicAdministrators/operationstatuses/read",
      "Microsoft.Authorization/denyAssignments/read",
      "Microsoft.Features/operations/read",
      "Microsoft.Features/features/read",
      "Microsoft.Features/providers/features/read",
      "Microsoft.Management/managementGroups/read",
      "Microsoft.Resources/tenants/read",
      "Microsoft.Resources/providers/read",
      "Microsoft.Resources/resources/read",
      "Microsoft.Resources/subscriptions/read",
      "Microsoft.Resources/subscriptions/resources/read",
      "Microsoft.Resources/subscriptions/locations/read",
      "Microsoft.Resources/subscriptions/providers/read",
      "Microsoft.Resources/subscriptions/operationresults/read",
      "Microsoft.Resources/subscriptions/resourceGroups/read",
      "Microsoft.Resources/subscriptions/resourcegroups/resources/read",
      "Microsoft.Resources/subscriptions/tagNames/read",
      "Microsoft.Resources/subscriptions/tagNames/tagValues/read",
      "Microsoft.Resources/deployments/read",
      "Microsoft.Resources/subscriptions/resourcegroups/deployments/read",
      "Microsoft.Resources/subscriptions/resourcegroups/deployments/operations/read",
      "Microsoft.Resources/subscriptions/resourcegroups/deployments/operationstatuses/read",
      "Microsoft.Resources/deployments/operations/read",
      "Microsoft.Resources/links/read",
      "Microsoft.Resources/tags/read",
    ]

    not_actions = [
      "Microsoft.Addons/register/action",
      "Microsoft.Addons/supportProviders/supportPlanTypes/write",
      "Microsoft.Addons/supportProviders/supportPlanTypes/delete",
      "Microsoft.Addons/supportProviders/listsupportplaninfo/action",
      "Microsoft.Authorization/elevateAccess/action",
      "Microsoft.Authorization/classicAdministrators/write",
      "Microsoft.Authorization/classicAdministrators/delete",
      "Microsoft.Authorization/roleAssignments/write",
      "Microsoft.Authorization/roleAssignments/delete",
      "Microsoft.Authorization/locks/write",
      "Microsoft.Authorization/locks/delete",
      "Microsoft.Authorization/roleDefinitions/write",
      "Microsoft.Authorization/roleDefinitions/delete",
      "Microsoft.Authorization/policySetDefinitions/write",
      "Microsoft.Authorization/policySetDefinitions/delete",
      "Microsoft.Authorization/policyDefinitions/write",
      "Microsoft.Authorization/policyDefinitions/delete",
      "Microsoft.Authorization/policyAssignments/write",
      "Microsoft.Authorization/policyAssignments/delete",
      "Microsoft.Authorization/denyAssignments/write",
      "Microsoft.Authorization/denyAssignments/delete",
      "Microsoft.Features/register/action",
      "Microsoft.Features/providers/features/register/action",
      "Microsoft.Features/providers/features/unregister/action",
      "Microsoft.Management/checkNameAvailability/action",
      "Microsoft.Management/getEntities/action",
      "Microsoft.Management/register/action",
      "Microsoft.Management/managementGroups/write",
      "Microsoft.Management/managementGroups/delete",
      "Microsoft.Management/managementGroups/subscriptions/write",
      "Microsoft.Management/managementGroups/subscriptions/delete",
      "Microsoft.Resources/checkResourceName/action",
      "Microsoft.Resources/checkPolicyCompliance/action",
      "Microsoft.Resources/subscriptions/resourceGroups/write",
      "Microsoft.Resources/subscriptions/resourceGroups/delete",
      "Microsoft.Resources/subscriptions/resourceGroups/moveResources/action",
      "Microsoft.Resources/subscriptions/resourceGroups/validateMoveResources/action",
      "Microsoft.Resources/subscriptions/tagNames/write",
      "Microsoft.Resources/subscriptions/tagNames/delete",
      "Microsoft.Resources/subscriptions/tagNames/tagValues/write",
      "Microsoft.Resources/subscriptions/tagNames/tagValues/delete",
      "Microsoft.Resources/deployments/write",
      "Microsoft.Resources/deployments/delete",
      "Microsoft.Resources/deployments/cancel/action",
      "Microsoft.Resources/deployments/validate/action",
      "Microsoft.Resources/deployments/whatIf/action",
      "Microsoft.Resources/subscriptions/resourcegroups/deployments/write",
      "Microsoft.Resources/links/write",
      "Microsoft.Resources/links/delete",
      "Microsoft.Resources/tags/write",
      "Microsoft.Resources/tags/delete",
    ]
  }
}

// NoAccess
resource "azurerm_role_definition" "azure_resource_manager_noaccess_definition" {
  name              = "azure-resource-manager-noaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = []

    not_actions = [
      "Microsoft.Addons/register/action",
      "Microsoft.Addons/supportProviders/supportPlanTypes/read",
      "Microsoft.Addons/supportProviders/supportPlanTypes/write",
      "Microsoft.Addons/supportProviders/supportPlanTypes/delete",
      "Microsoft.Addons/operations/read",
      "Microsoft.Addons/supportProviders/listsupportplaninfo/action",
      "Microsoft.Authorization/elevateAccess/action",
      "Microsoft.Authorization/classicAdministrators/read",
      "Microsoft.Authorization/classicAdministrators/write",
      "Microsoft.Authorization/classicAdministrators/delete",
      "Microsoft.Authorization/roleAssignments/read",
      "Microsoft.Authorization/roleAssignments/write",
      "Microsoft.Authorization/roleAssignments/delete",
      "Microsoft.Authorization/permissions/read",
      "Microsoft.Authorization/locks/read",
      "Microsoft.Authorization/locks/write",
      "Microsoft.Authorization/locks/delete",
      "Microsoft.Authorization/roleDefinitions/read",
      "Microsoft.Authorization/roleDefinitions/write",
      "Microsoft.Authorization/roleDefinitions/delete",
      "Microsoft.Authorization/providerOperations/read",
      "Microsoft.Authorization/policySetDefinitions/read",
      "Microsoft.Authorization/policySetDefinitions/write",
      "Microsoft.Authorization/policySetDefinitions/delete",
      "Microsoft.Authorization/policyDefinitions/read",
      "Microsoft.Authorization/policyDefinitions/write",
      "Microsoft.Authorization/policyDefinitions/delete",
      "Microsoft.Authorization/policyAssignments/read",
      "Microsoft.Authorization/policyAssignments/write",
      "Microsoft.Authorization/policyAssignments/delete",
      "Microsoft.Authorization/operations/read",
      "Microsoft.Authorization/classicAdministrators/operationstatuses/read",
      "Microsoft.Authorization/denyAssignments/read",
      "Microsoft.Authorization/denyAssignments/write",
      "Microsoft.Authorization/denyAssignments/delete",
      "Microsoft.Features/register/action",
      "Microsoft.Features/operations/read",
      "Microsoft.Features/features/read",
      "Microsoft.Features/providers/features/read",
      "Microsoft.Features/providers/features/register/action",
      "Microsoft.Features/providers/features/unregister/action",
      "Microsoft.Management/checkNameAvailability/action",
      "Microsoft.Management/getEntities/action",
      "Microsoft.Management/register/action",
      "Microsoft.Management/managementGroups/read",
      "Microsoft.Management/managementGroups/write",
      "Microsoft.Management/managementGroups/delete",
      "Microsoft.Management/managementGroups/subscriptions/write",
      "Microsoft.Management/managementGroups/subscriptions/delete",
      "Microsoft.Resources/checkResourceName/action",
      "Microsoft.Resources/checkPolicyCompliance/action",
      "Microsoft.Resources/tenants/read",
      "Microsoft.Resources/providers/read",
      "Microsoft.Resources/resources/read",
      "Microsoft.Resources/subscriptions/read",
      "Microsoft.Resources/subscriptions/resources/read",
      "Microsoft.Resources/subscriptions/locations/read",
      "Microsoft.Resources/subscriptions/providers/read",
      "Microsoft.Resources/subscriptions/operationresults/read",
      "Microsoft.Resources/subscriptions/resourceGroups/read",
      "Microsoft.Resources/subscriptions/resourceGroups/write",
      "Microsoft.Resources/subscriptions/resourceGroups/delete",
      "Microsoft.Resources/subscriptions/resourceGroups/moveResources/action",
      "Microsoft.Resources/subscriptions/resourceGroups/validateMoveResources/action",
      "Microsoft.Resources/subscriptions/resourcegroups/resources/read",
      "Microsoft.Resources/subscriptions/tagNames/read",
      "Microsoft.Resources/subscriptions/tagNames/write",
      "Microsoft.Resources/subscriptions/tagNames/delete",
      "Microsoft.Resources/subscriptions/tagNames/tagValues/read",
      "Microsoft.Resources/subscriptions/tagNames/tagValues/write",
      "Microsoft.Resources/subscriptions/tagNames/tagValues/delete",
      "Microsoft.Resources/deployments/read",
      "Microsoft.Resources/deployments/write",
      "Microsoft.Resources/deployments/delete",
      "Microsoft.Resources/deployments/cancel/action",
      "Microsoft.Resources/deployments/validate/action",
      "Microsoft.Resources/deployments/whatIf/action",
      "Microsoft.Resources/subscriptions/resourcegroups/deployments/read",
      "Microsoft.Resources/subscriptions/resourcegroups/deployments/write",
      "Microsoft.Resources/subscriptions/resourcegroups/deployments/operations/read",
      "Microsoft.Resources/subscriptions/resourcegroups/deployments/operationstatuses/read",
      "Microsoft.Resources/deployments/operations/read",
      "Microsoft.Resources/links/read",
      "Microsoft.Resources/links/write",
      "Microsoft.Resources/links/delete",
      "Microsoft.Resources/tags/read",
      "Microsoft.Resources/tags/write",
      "Microsoft.Resources/tags/delete",
    ]
  }
}
